describe("The paintutils library", function()
    describe("paintutils.parseImage", function()
        it("validates arguments", function()
            paintutils.parseImage("")
            expect.error(paintutils.parseImage, nil):eq("bad argument #1 (expected string, got nil)")
        end)
    end)

    describe("paintutils.loadImage", function()
        it("validates arguments", function()
            expect.error(paintutils.loadImage, nil):eq("bad argument #1 (expected string, got nil)")
        end)
    end)

    describe("paintutils.drawPixel", function()
        it("validates arguments", function()
            expect.error(paintutils.drawPixel, nil):eq("bad argument #1 (expected number, got nil)")
            expect.error(paintutils.drawPixel, 1, nil):eq("bad argument #2 (expected number, got nil)")
            expect.error(paintutils.drawPixel, 1, 1, false):eq("bad argument #3 (expected number, got boolean)")
        end)
    end)

    describe("paintutils.drawLine", function()
        it("validates arguments", function()
            expect.error(paintutils.drawLine, nil):eq("bad argument #1 (expected number, got nil)")
            expect.error(paintutils.drawLine, 1, nil):eq("bad argument #2 (expected number, got nil)")
            expect.error(paintutils.drawLine, 1, 1, nil):eq("bad argument #3 (expected number, got nil)")
            expect.error(paintutils.drawLine, 1, 1, 1, nil):eq("bad argument #4 (expected number, got nil)")
            expect.error(paintutils.drawLine, 1, 1, 1, 1, false):eq("bad argument #5 (expected number, got boolean)")
        end)
    end)

    describe("paintutils.drawBox", function()
        it("validates arguments", function()
            expect.error(paintutils.drawBox, nil):eq("bad argument #1 (expected number, got nil)")
            expect.error(paintutils.drawBox, 1, nil):eq("bad argument #2 (expected number, got nil)")
            expect.error(paintutils.drawBox, 1, 1, nil):eq("bad argument #3 (expected number, got nil)")
            expect.error(paintutils.drawBox, 1, 1, 1, nil):eq("bad argument #4 (expected number, got nil)")
            expect.error(paintutils.drawBox, 1, 1, 1, 1, false):eq("bad argument #5 (expected number, got boolean)")
        end)
    end)

    describe("paintutils.drawFilledBox", function()
        it("validates arguments", function()
            expect.error(paintutils.drawFilledBox, nil):eq("bad argument #1 (expected number, got nil)")
            expect.error(paintutils.drawFilledBox, 1, nil):eq("bad argument #2 (expected number, got nil)")
            expect.error(paintutils.drawFilledBox, 1, 1, nil):eq("bad argument #3 (expected number, got nil)")
            expect.error(paintutils.drawFilledBox, 1, 1, 1, nil):eq("bad argument #4 (expected number, got nil)")
            expect.error(paintutils.drawFilledBox, 1, 1, 1, 1, false):eq("bad argument #5 (expected number, got boolean)")
        end)
    end)

    describe("paintutils.drawImage", function()
        it("validates arguments", function()
            expect.error(paintutils.drawImage, nil):eq("bad argument #1 (expected table, got nil)")
            expect.error(paintutils.drawImage, {}, nil):eq("bad argument #2 (expected number, got nil)")
            expect.error(paintutils.drawImage, {}, 1, nil):eq("bad argument #3 (expected number, got nil)")
        end)
    end)
end)
